# _surface.h File Reference

`#include "_pen.h"`
`#include "_misc.h"`
`#include <algorithm>`
`#include <cstring>`

Go to the source code of this file.

## Classes

class | value_prep< T, AT >
class | surface< T, AT, VP >

## Defines

#define | f(j, i) (cooker_.cook((*this)[j][i]))

## Define Documentation

#define f | ( | j,
|  | i |  | ) | (cooker_.cook((*this)[j][i]))

Referenced by surface< T, AT, VP >::cosine_sample(), surface< T, AT, VP >::cubic_sample(), fastangle::radians::get(), hbox_blur(), surface< T, AT, VP >::linear_sample(), fastangle::operator~(), clock_desc_gettimeofday::precision(), fastangle::radians::radians(), clock_desc_sys_time::seconds_to_timestamp(), and vbox_blur().